#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cassert>

#include<set>
#include<map>
#include<list>
#include<vector>
#include<algorithm>
#include<utility>
#include<queue>
#include<string>

using namespace std;


int cave_belongs_to_union[300002];
int union_size[100002];
list<int> union_caves[100002];

void MergeUnions(int a, int b){
	int i,j;
	if(a==b)return;
	
	if(union_size[a]<union_size[b]){
		i=a;
		a=b;
		b=i;
	}
	
	//printf("Merging unions %d and %d, size %d and %d\n",a,b,union_size[a], union_size[b]);
	
	union_size[a]+=union_size[b];
	union_size[b]=0;
	
	list<int>::iterator it=union_caves[b].begin();
	j=union_caves[b].size();
	for(i=0;i<j;i++,it++){
		//printf("Adding cave %d to union %d\n",*it,a);
		cave_belongs_to_union[*it]=a;
	}
	union_caves[a].splice(union_caves[a].end(),union_caves[b]);
	
}

int main(){
	
	int i,j,k,d,e;
	
	FILE *in,*out;
	
	int n,m,q,a,b;
	
	char inp[2];
	
	in=fopen("caves.in","r");
	assert(in);
	out=fopen("caves.out","w");
	
	fscanf(in,"%d %d",&n,&m);
	
	for(i=1;i<=n;i++){
		cave_belongs_to_union[i]=i;
		union_size[i]=1;
		union_caves[i].push_back(i);
	}
	
	for(i=0;i<m;i++){
		fscanf(in,"%d %d",&a,&b);
		MergeUnions(cave_belongs_to_union[a],cave_belongs_to_union[b]);
	}
	
	fscanf(in,"%d",&q);
	
	for(i=0;i<q;i++){
		fscanf(in,"%s %d %d",&inp,&a,&b);
		if(inp[0]=='Q'){
			if(cave_belongs_to_union[b]==cave_belongs_to_union[a]){
				fprintf(out,"Y\n");
			}
			else{
				fprintf(out,"N\n");
			}
		}
		else if(inp[0]=='P'){
			MergeUnions(cave_belongs_to_union[a],cave_belongs_to_union[b]);
		}
		else{
			cave_belongs_to_union[a]=cave_belongs_to_union[b];
			union_size[cave_belongs_to_union[b]]++;
			union_caves[cave_belongs_to_union[b]].push_back(a);
		}
	}
	
	
	fclose(in);
	fclose(out);
	return 0;
}
